<template>
    <div class="app-container calendar-list-container">

        <!-- 查询和其他操作 -->
        <div class="filter-container">
            <el-button class="filter-item" type="primary" @click="handleCreate" icon="el-icon-edit">添加</el-button>
        </div>

        <!-- 查询结果 -->
        <el-table size="small" :data="list" v-loading="listLoading"
            element-loading-text="正在查询中。。。" border fit highlight-current-row>
            <el-table-column type="index" label="序号" header-align="center" align="center">
            </el-table-column>
            <el-table-column align="center" min-width="60px" label="员工号" prop="employeNo">
            </el-table-column>
            <el-table-column align="center" min-width="100px" label="姓名" prop="userName">
            </el-table-column>
            <el-table-column align="center" min-width="60px" label="部门" prop="deptName">
            </el-table-column>
            <el-table-column align="center" min-width="60px" label="创建时间" prop="createTime">
            </el-table-column>
            <el-table-column align="center" label="操作" width="240px" class-name="small-padding fixed-width">
                <template slot-scope="scope">
                    <el-button type="primary" size="small" @click="handleUpdate(scope.row, false)">编辑</el-button>

                    <el-button type="danger" size="mini" @click="handleDelete(scope.row)">删除</el-button>
                </template>
            </el-table-column>
        </el-table>

        <!-- 分页 -->
        <div class="pagination-container">
            <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
                :current-page="listQuery.page" :page-sizes="[10, 20, 30, 50]" :page-size="listQuery.limit"
                layout="total, sizes, prev, pager, next, jumper" :total="total">
            </el-pagination>
        </div>

        <!-- 添加或修改对话框 -->
        <el-dialog
        :close-on-click-modal="false"
        :title="textMap[dialogStatus]"
        :visible.sync="dialogFormVisible"
        width="70%"
      >
        <el-form :rules="rules" ref="dataForm" :model="dataForm" status-icon label-position="left" label-width="80px" style='width: 700px; margin-left:50px;'>
            <el-form-item label="表彰人" prop="loginId">
                <el-select v-model="dataForm.loginId" clearable filterable placeholder="请选择" style="width: 350px">
                    <el-option :key="item.loginId" v-for="item in recipientsList" :label="item.deptName+'_'+item.userName+'_'+item.employeNo" :value="item.loginId">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item
                    style="width: 800px"
                    label="表彰内容"
                    prop="content"
                    >
                <tinymce v-model="dataForm.content" ref="tinymce"></tinymce>
            </el-form-item>
            
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button @click="dialogFormVisible = false">取消</el-button>
          <el-button v-if="dialogStatus == 'create'" type="primary" @click="createData">确定</el-button>
          <el-button v-else type="primary" @click="updateData">确定</el-button>
        </div>
      </el-dialog>

    </div>
</template>
  
<style>
.demo-table-expand {
    font-size: 0;
}

.demo-table-expand label {
    width: 200px;
    color: #99a9bf;
}

.demo-table-expand .el-form-item {
    margin-right: 0;
    margin-bottom: 0;
}
</style>
  
<script>
import { dataList, dataAdd, dataEdit, dataRemove } from "@/api/commendManage";
import { allUserList } from "@/api/public";
import waves from "@/directive/waves"; // 水波纹指令
import Tinymce from '@/components/Tinymce'

export default {
    components: { Tinymce },
    directives: { waves },
    data() {
        return {
            recipientsList:[],
            list: [
            ],
            total: 0,
            listLoading: false,
            listQuery: {
                page: 1,
                limit: 10,
                commendId:this.$route.params.id
            },
            dataForm: {
                commendId:this.$route.params.id,
                loginId: undefined,
                content: undefined,
            },
            dialogFormVisible: false,
            dialogStatus: '',
            textMap: {
                update: "编辑",
                create: "创建",
            },
            rules: {
                loginId: [{ required: true, message: "请选择表彰人", trigger: "blur" }],
                content: [{ required: true, message: "表彰内容不能为空", trigger: "blur" }],
            },
        }
    },
    created() {
        this.getAllUserList(); 
        this.getList();
    },
    methods: {
        getAllUserList() {
            allUserList().then(response => {
                this.recipientsList = response.data.data;
            }).catch(() => { });
        },
        resetForm() {
            this.dataForm = {
                commendId:this.$route.params.id,
                loginId: undefined,
                content: undefined,
            };
        },
        handleCreate() {
            this.resetForm();
            this.dataForm.dictType = this.dictType;
            this.dialogFormVisible = true;
            this.dialogStatus = "create";
            this.$nextTick(() => {
                this.$refs.tinymce.setContent("");
                this.$refs["dataForm"].clearValidate();
            });
        },
        createData() {
            this.$refs["dataForm"].validate((valid) => {
                if (valid) {
                    dataAdd(this.dataForm)
                        .then(() => {
                            this.dialogFormVisible = false;

                            this.$notify({
                                title: "成功",
                                message: "创建成功",
                                type: "success",
                                duration: 2000,
                            });
                            this.getList()
                        })
                }
            });
        },
        getList() {
            this.listLoading = true
            dataList(this.listQuery).then(response => {
                this.list = response.data.data.items
                this.total = response.data.data.total
                this.listLoading = false
            }).catch(() => {
                this.list = []
                this.total = 0
                this.listLoading = false
            })
        },

        handleFilter() {
            this.listQuery.page = 1
            this.getList()
        },

        handleSizeChange(val) {
            this.listQuery.limit = val
            this.getList()
        },

        handleCurrentChange(val) {
            this.listQuery.page = val
            this.getList()
        },

        handleUpdate(row) {
            this.dataForm = Object.assign({}, row);
            let content = this.dataForm.content;
            this.dialogStatus = 'update'
            this.dialogFormVisible = true
            this.$nextTick(() => {
                this.$refs.tinymce.setContent(content);
                this.$refs['dataForm'].clearValidate();
            })
        },

        updateData() {
            this.$refs['dataForm'].validate((valid) => {
                if (valid) {
                    dataEdit(this.dataForm).then(() => {
                        this.dialogFormVisible = false
                        this.$notify({
                            title: '成功',
                            message: '更新成功',
                            type: 'success',
                            duration: 2000
                        })
                        this.getList()
                    })

                }
            })
        },

        handleDelete(row) {

            this.$confirm('确认删除吗?', '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                type: 'warning'
            }).then(() => {
                dataRemove({ id:row.id}).then(response => {
                    this.$notify({
                        title: '成功',
                        message: '删除成功',
                        type: 'success',
                        duration: 2000
                    })
                    const index = this.list.indexOf(row)
                    this.list.splice(index, 1)
                })
            }).catch(() => {

            })

        },
    }
}
</script>
<style>
.ad-avatar-uploader .el-upload {
    border: 1px dashed #d9d9d9;
    border-radius: 6px;
    cursor: pointer;
    position: relative;
    overflow: hidden;
}

.ad-avatar-uploader .el-upload:hover {
    border-color: #409EFF;
}

.ad-avatar-uploader-icon {
    font-size: 28px;
    color: #8c939d;
    width: 178px;
    height: 178px;
    line-height: 178px;
    text-align: center;
}

.ad-avatar {
    display: block;
}
</style>
  